(function () {
    "use strict";

    angular.module('core').controller('composicaoImpostoController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$alert', 'composicaoImpostoService', 'lookupService', '$q'];

    function controller($scope, $timeout, $state, $alert, composicaoImpostoService, lookupService, $q) {
        $scope.initializeLayout('Composição de Impostos');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    composicaoImposto: {
                        Ativo: null,
                    },
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            }
        };


        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                save: function () {
                    $scope.state.salvando = true;
                    composicaoImpostoService
                        .save($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ text: response.Message, title: $scope.Title });
                                } else {
                                    $scope.popups.add.ativo = false;
                                    $scope.popups.add.data = {};
                                    $scope.refresh();

                                    $state.go("state-composicao-imposto-edit", { id: response.Data.ID });
                                }

                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                prepare: function () {
                    composicaoImpostoService
                        .prepareNew()
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                    $scope.popups.add.ativo = false;
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $timeout(function () { $('[ng-model*="popups.add.data.Criterios.NaturezaOperacao.Nome"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.popups.edit.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepare();
                    }

                }
            }
        };

        $scope.auxiliar = {

            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            operacaofiscal: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCodigoFiscalOperacao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            naturezaoperacao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllNaturezaOperacao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            grupoFiscalProduto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoFiscalProduto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            grupoFiscalEmpresa: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoFiscalEmpresa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            estado: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllEstado({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            origemtributo: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllOrigemTributo({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            produto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllProduto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            getallcomposicao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoComposicaoImposto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            empresa: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllEmpresa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            codigofiscal: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCodigoFiscalOperacao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            composicaoImpostoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            composicaoImpostoService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            composicaoImpostoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args.chaves = '';
            $scope.state.filtro.args.composicaoImposto.Ativo = null;

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();